//-----------------------------------------------------------------------------
//
// 2.5D[Vu[
//
//-----------------------------------------------------------------------------

texture		MeshTexture;						// fJ[eNX`
texture		RenderTarget;						// ʏ`peNX`
texture		VelocityMap;						// x}bv
texture		DepthMap;						// Z}bv

// staticmesh
float4x4	WorldViewProjection;					// ϊs
float4x4	OldWorldViewProjection;				// O̕ϊs
float4x4	WorldView;							// [hEr[s
float4x4	OldWorldView;							// Õ[hEr[s
float4x4	OldViewProjection;						// Õr[es

// ProjectionMatrix Param
float		fProj11;
float		fProj22;
float		fProj33;
float		fProj43;
float		fBias = 0.001f;							// ZoCAX

// _VF[_
struct VS_INPUT0
{
	float4	Position	: POSITION;
	float3	Normal	: NORMAL0;
	float2	MeshUV	: TEXCOORD0;
};

// ŏIo͗p
struct VS_INPUT1
{
	float4	vPos	: POSITION;
	float2	vTex	: TEXCOORD0;
};

// _VF[_o
struct VS_OUTPUT
{
	float4	Position	: POSITION;
	float4	Color		: COLOR0;
	float3	MeshUV	: TEXCOORD0;
};

// Tv
sampler MeshSampler = sampler_state
{
	texture = <MeshTexture>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	//AddressU = WRAP;
	//AddressV = WRAP;
};
// _O^[Qbg
sampler RenderTargetSampler = sampler_state
{
	texture = <RenderTarget>;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// x}bvTv
sampler VelocityMapSampler = sampler_state
{
	texture = <VelocityMap>;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// [xeNX`Tv
sampler DepthMapSampler = sampler_state
{
	texture = <DepthMap>;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


//------------------------------------------------------------------------------
//
// x}bv`
//
//------------------------------------------------------------------------------
VS_OUTPUT VelocityMapVertexShader(const VS_INPUT0 Input)
{
	VS_OUTPUT	Output = (VS_OUTPUT)0;
	float4		now_pos, prev_pos, n;
	float3		vel, norm;
	float			d;

	// ƑÖʒuvZ
	now_pos  = mul(Input.Position, WorldView);
	prev_pos = mul(Input.Position, OldWorldView);

	// x߂
	vel.xyz = now_pos.xyz - prev_pos.xyz;

	// @]
	n.xyz = Input.Normal;
	n.w = 0.0f;
	norm.xyz = mul(n, WorldView);

	// Wϊ
	now_pos  = mul(Input.Position, WorldViewProjection);
	prev_pos = mul(Input.Position, OldWorldViewProjection);

	// @Ƒx̃xNg̓ςo͂钸_W肷
	d = dot(norm, vel);
	d = step(0.0f, d);

	float4 o_pos = d * now_pos + (1.0f - d) * prev_pos;
	Output.Position = o_pos;

	// J[ɑxo͂
	now_pos.xy = now_pos.xy / now_pos.w;
	prev_pos.xy = prev_pos.xy / prev_pos.w;
	
	// UVZo
	Output.MeshUV.x = (now_pos.x - prev_pos.x);
	Output.MeshUV.y = -(now_pos.y - prev_pos.y);
	Output.MeshUV.z = o_pos.z / o_pos.w;

	return Output;
}

// ŏI`
VS_OUTPUT SynthesisVertexShader(const VS_INPUT1 Input)
{
	VS_OUTPUT	Output = (VS_OUTPUT)0;

	Output.Position = Input.vPos;

	Output.MeshUV.xy = Input.vTex.xy;

	return Output;
}

// Z}bv`
VS_OUTPUT CreateDepthMapVertexShader(const VS_INPUT0 Input)
{
	VS_OUTPUT	Output = (VS_OUTPUT)0;

	// Wϊ
	float4		pos;
	pos = mul(Input.Position, WorldViewProjection);
	Output.Position = pos;

	// ZRHWn
	Output.Color.xy = 1.0f;
	Output.Color.z = pos.z / pos.w;
	Output.Color.w = 1.0f / pos.w;

	return Output;
}

//------------------------------------------------------------------------------
//
//  x}bvsNZVF[_
//
//------------------------------------------------------------------------------
float4 VelocityMapPixelShader(const VS_OUTPUT Input) : COLOR
{
	float4	Output;

	Output.rgb = Input.MeshUV.xyz;
	Output.a = 1.0f;

	return Output;
}

// u[`( ŏIo )
float4 SynthesisPixelShader(const VS_OUTPUT v) : COLOR
{
	float4	Out;
	float2	vel;

	
	vel = tex2D(VelocityMapSampler, v.MeshUV.xy) / 3.0f;
	
	
	Out = tex2D(RenderTargetSampler, v.MeshUV.xy)
		+ tex2D(RenderTargetSampler, v.MeshUV.xy + vel * 1.0f)
		+ tex2D(RenderTargetSampler, v.MeshUV.xy + vel * 2.0f)
		+ tex2D(RenderTargetSampler, v.MeshUV.xy + vel * 3.0f);
	Out = Out / 4.0f;

	return Out;
}
// Z`FbNu[`
float4 psFinalCheckZ(const VS_OUTPUT Input) : COLOR
{
	float4	Out;
	float4	vel;
	float4	chkz;
	float2	uv;
	float	div = 1.0f;

	// x߂
	vel = tex2D(VelocityMapSampler, Input.MeshUV.xy);
	vel.xy /= 3.0f;
	vel.z -= fBias;

	// esNZ̃J[߂
	Out = tex2D(RenderTargetSampler, Input.MeshUV.xy);
	uv = Input.MeshUV.xy + vel.xy;
	chkz = tex2D(VelocityMapSampler, uv);
	if(chkz.z >= vel.z)
	{
		div += 1.0f;
		Out += tex2D(RenderTargetSampler, uv);
	}
	uv = uv + vel.xy;
	chkz = tex2D(VelocityMapSampler, uv);
	if(chkz.z >= vel.z){
		div += 1.0f;
		Out += tex2D(RenderTargetSampler, uv);
	}
	uv = uv + vel.xy;
	chkz = tex2D(VelocityMapSampler, uv);
	if(chkz.z >= vel.z){
		div += 1.0f;
		Out += tex2D(RenderTargetSampler, uv);
	}

	// ŏIo͂߂
	return Out / div;
}
// ʏ`\
float4 psFinalDrawTex(const VS_OUTPUT Input) : COLOR
{
	return tex2D(RenderTargetSampler, Input.MeshUV.xy);
}
// x}bv\
float4 psFinalVelTex(const VS_OUTPUT Input) : COLOR
{
	return tex2D(VelocityMapSampler, Input.MeshUV.xy);
}
// Z}bv`
float4 psZMap(const VS_OUTPUT Input) : COLOR
{
	return Input.Color;
}

// Õpx}bv`
float4 StaticVelocityNoMovePixelShader(const VS_OUTPUT Input) : COLOR
{
	float4	Out;
	float4	vZ = tex2D(DepthMapSampler, Input.MeshUV.xy);
	float4	vPos, vCurPos, vOldPos;

	// r[ԏ̍W߂
	vCurPos.x =  Input.MeshUV.x * 2.0f - 1.0f;
	vCurPos.y = -Input.MeshUV.y * 2.0f + 1.0f;
	vPos.x = vCurPos.x / vZ.w / fProj11;
	vPos.y = vCurPos.y / vZ.w / fProj22;
	vPos.z = (vZ.z / vZ.w) + fProj33 / fProj43;
	vPos.w = 1.0f;

	// ÕXN[W߂
	vOldPos = mul(vPos, OldViewProjection);

	// x߂
	vOldPos.xy = vOldPos.xy / vOldPos.w;
	Out.x =  (vCurPos.x - vOldPos.x);
	Out.y = -(vCurPos.y - vOldPos.y);
	Out.z = vZ.z;
	Out.xyz = Out.xyz * vZ.x;
	Out.w = 1.0f;

	return Out;
}

//--------------------------------------------------------------------------------
//
// eNjbN
//
//--------------------------------------------------------------------------------


// x}bv쐬
technique CreateVelocity
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 VelocityMapVertexShader();
		PixelShader = compile ps_2_0 VelocityMapPixelShader();

		ZEnable = TRUE;
		AlphaBlendEnable = False;
	}
}

// u[`
technique Output
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 SynthesisVertexShader();
		PixelShader = compile ps_2_0 SynthesisPixelShader();

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

// Z`FbNu[`
technique OutputCheckZ
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 SynthesisVertexShader();
		PixelShader = compile ps_2_0 psFinalCheckZ();

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

// x}bv\
technique RenderVelocityMap
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 SynthesisVertexShader();
		PixelShader = compile ps_2_0 psFinalVelTex();

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

// Z}bv`
technique CreateDepthMap
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 CreateDepthMapVertexShader();
		PixelShader = compile ps_2_0 psZMap();

		ZEnable = TRUE;
		AlphaBlendEnable = False;
	}
}

// ÓI̗p
technique StaticVelocityNoMove
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 SynthesisVertexShader();
		PixelShader = compile ps_2_0 StaticVelocityNoMovePixelShader();

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}
