//--------------------------------------------------------------------------------------
// FxFileTv : DisplaceMentMappingLib
//
// 
// 
// 
//--------------------------------------------------------------------------------------




//---------------------------------------------------------------------
//
// SKinMesh
//
//---------------------------------------------------------------------
static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ] : WORLDMATRIXARRAY;
float4x4 ViewProjection : VIEWPROJECTIONMATRIX;




//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------
float	 GlobalTime;							// App's time in seconds
float4x4 WorldViewProjection;					// World matrix for object
float DisplaceMentValue = 0.2f;				// fBXv[XW



texture MeshTexture;

sampler MeshSampler = sampler_state
{
	Texture = < MeshTexture >;
	//tB^ݒ
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;    
    //eNX`bsO
    AddressU = Wrap;
    AddressV = Wrap;
};

// fBXv[Xg}bv
texture	DisplaceMentTexture;		//eNX`
sampler Displacement = sampler_state
{
    Texture = <DisplaceMentTexture>;
	//tB^ݒ
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;    
    //eNX`bsO
    AddressU = Wrap;
    AddressV = Wrap;
};


//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float4 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal			: NORMAL;
    float2  TextureCoord    : TEXCOORD0;
};



// o͍\
struct VS_DISPLACEMENTMAP_OUTPUT
{
	float4 Pos:	POSITION;
	float2 TextureUV:	TEXCOORD0;
};


//----------------------------------------------------------------------------------------------------------------------------------------
// Tv   : _XLjO֐
//    : XLbV͍\ , _e󂯂{[s̐
// ߂l : XLbVo͍\
//----------------------------------------------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_Skinning( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output = (VS_SKINNINGOUTPUT)0;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        NormalVector += mul( Input.Normal , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        
    }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s    
    
    
  
    
    // Vector𐳋K
    Output.Normal = normalize(  NormalVector  );
    
    
    
    

    // DiffuseZo
 //   Output.Diffuse.xyz = MaterialAmbient.xyz + Diffuse( NormalVector , LightDiffuse  ) * MaterialDiffuse.xyz;
  //  Output.Diffuse.w = 1.0f;


    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
    

    
	return Output;
}



//----------------------------------------------------------------------------------------
// Tv   : ʏ̃fBXv[Xg}bsO
//    : WorldϊŃXLjOς݂̒_ƕ , TextureCoord
// ߂lyяo : Displaycement_TextureCoord
//-----------------------------------------------------------------------------------------
VS_DISPLACEMENTMAP_OUTPUT StaticVertexShader_DisplacementMap(
	float4 Pos:	POSITION,
	float3 Normal:		NORMAL,
	float2 TextureUV:	TEXCOORD0)
{
	VS_DISPLACEMENTMAP_OUTPUT Out;
	
	// RŃfBXv[X
	Pos.xyz +=  Normal * (tex2Dlod( Displacement , float4( TextureUV ,  0 , 1 )).x - 0.5f)
	 * ( DisplaceMentValue * 0.1f );
	 
	// tex2Dlod : }bsOłȂ~bvx̐䂪ł֐B
	// 2float2ł͂Ȃfloat4ŁAw~bvxɎgp
	
	// ˉeϊ
	Out.Pos = mul( Pos , WorldViewProjection );
	Out.TextureUV = TextureUV;
	
	return Out;
}

//----------------------------------------------------------------------------------------
// Tv   : ʏ̃fBXv[Xg}bsO
//    : WorldϊŃXLjOς݂̒_ƕ , TextureCoord
// ߂lyяo : Displaycement_TextureCoord
//-----------------------------------------------------------------------------------------
VS_DISPLACEMENTMAP_OUTPUT StaticVertexShader_DisplaceMentSinTime(float4 Pos:	POSITION,
	float3 Normal:		NORMAL,
	float2 TextureUV:	TEXCOORD0)
{
	VS_DISPLACEMENTMAP_OUTPUT Out;
	
	// RɃTČWăfBXv[X
	Pos.xyz +=  Normal * ( tex2Dlod( Displacement , float4( TextureUV , 0 , 1 ) ).x - 0.5f )
	 * sin(GlobalTime);
	 
	Out.Pos = mul( Pos , WorldViewProjection);
	Out.TextureUV = TextureUV;
	
	return Out;
}
//--------------------------------------------------------------------------------------------------
//
// Pixel Shader
//
//---------------------------------------------------------------------------------------------------
float4 StaticPixcelShader_DisplaceMentMap( float2 TextureUV : TEXCOORD0 ) : COLOR
{
	// MeshtexturẽTvVertexShaderŏo͂TextureCoord
	return tex2D( MeshSampler, TextureUV );
}

//----------------------------------------------------------------------------------------
// Tv   : ʏ̃fBXv[Xg}bsO
//    : WorldϊŃXLjOς݂̒_ƕ , TextureCoord
// ߂lyяo : Displaycement_TextureCoord
//-----------------------------------------------------------------------------------------
VS_DISPLACEMENTMAP_OUTPUT SkinMeshVertexShader_DisplacementMap(
	VS_SKINNING Input , uniform int NumBones )
{
	VS_DISPLACEMENTMAP_OUTPUT Out;
	
	
	VS_SKINNINGOUTPUT SkinOut = Vertex_Skinning( Input , NumBones );
	
	// RŃfBXv[X
	SkinOut.Pos.xyz +=  SkinOut.Normal * (tex2Dlod( Displacement , float4( SkinOut.TextureCoord ,  0 , 1 )).x - 0.5f)
	 * ( DisplaceMentValue * 0.1f );
	 
	// tex2Dlod : }bsOłȂ~bvx̐䂪ł֐B
	// 2float2ł͂Ȃfloat4ŁAw~bvxɎgp
	
	// ˉeϊ
	Out.Pos = mul( float4(SkinOut.Pos.xyz , 1.0f ) ,ViewProjection );
	Out.TextureUV = SkinOut.TextureCoord;
	
	return Out;
}


int CurNumBones = 2;
VertexShader DisplaceVertexArray[4] = {
				compile vs_3_0 SkinMeshVertexShader_DisplacementMap(1), 
                            compile vs_3_0 SkinMeshVertexShader_DisplacementMap(2),
                            compile vs_3_0 SkinMeshVertexShader_DisplacementMap(3),
                            compile vs_3_0 SkinMeshVertexShader_DisplacementMap(4)
                          };

//--------------------------------------------------------------------------------------
//
// Techniques : GFoceFx6800ȍ~ȂHLSL 3.0gȂ
//
//--------------------------------------------------------------------------------------
technique StaticDisplaceMentMap
{    
    pass Pass0
    {
		// fBXv[Xg}bsO
	    VertexShader = compile vs_3_0 StaticVertexShader_DisplacementMap();
	    PixelShader = compile ps_1_1 StaticPixcelShader_DisplaceMentMap();		
    }
     
    pass Pass1
    {
		// sinŃfBXv[X
		VertexShader = compile vs_3_0 StaticVertexShader_DisplaceMentSinTime();
		PixelShader = compile ps_1_1 StaticPixcelShader_DisplaceMentMap();		
    }
}


technique SkinMeshDisplaceMentMap
{
	pass Pass0
	{
		//CullMode = CW;
		VertexShader = ( DisplaceVertexArray[ CurNumBones ] );
		PixelShader = compile ps_1_1 StaticPixcelShader_DisplaceMentMap();
	}
}