//==========================================================================
// SkinMesh
//==========================================================================

//SkinMeshParam
static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ];

float4x4 ViewMatrix;
//float4x4 ProjectionMatrix;

float4x4 ViewProjection;



//=========================================================================
// staticMesh
//=========================================================================
float4x4 WorldMatrix;		// [hs
float4x4 WoldViewProjection;		// [hr[ˉe


//=========================================================================
//  : MeshǗNXŏɃZbgĂ
//=========================================================================
float4 MaterialDiffuse;		// Cgƃ}eA̐F
float4 MaterialSpecular;	// Cgƃ}eÃXyL
float4 MaterialAmbient;		// Cgƃ}eA
float MaterialPower;		// }eÃXyL̗
texture MeshTexture;	// }eÃeNX`

// fBNViCg̕
float3 LightDirection;



float3 Eyepos;	// _̈ʒu

// HDRp
texture InputTexture;
texture BloomTexture;
float2 SampleOffset[3];
float SampleWeight[3];

//==============================================================
// eNX`Tv
//	EgpeNX`̃TvXe[gݒ
sampler MeshSmp=sampler_state
{
	Texture=<MeshTexture>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

sampler InputSmp=sampler_state
{
	Texture=<InputTexture>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=BORDER;
	AddressV=BORDER;
};
// u[p
sampler BloomSmp=sampler_state
{
	Texture=<BloomTexture>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=BORDER;
	AddressV=BORDER;
};



//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float4 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal			: NORMAL;
    float2  TextureCoord    : TEXCOORD0;
};


//------------------------------------------------------------------------------------------------
// Tv   : _XLjOĕVector3X3sŕϊ( Normalize͊eōs ) 
//    : XLbV͍\
// ߂l : XLbVo͍\
//------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_TransformNormal( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

    // Toon
    float3 _Normal = 0.0f;
    
     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
       
       // Vector]̂( 3X3s )ŕϊ
        NormalVector += mul( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
   }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s
    
    
    Output.Pos = float4( Position , 1.0 );
    Output.Normal = NormalVector;
    
    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
	return Output;
}


//==============================================================
// ʏ`
//==============================================================
// _VF[_sNZVF[_ɓnf[^p\
struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;
	float4 Spe		: COLOR1;
	float2 MeshUV	: TEXCOORD0;
};

// _VF[_
//	E_PĂ̂ŁAsNZVF[_ɓnB
VS_OUTPUT VS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
	VS_OUTPUT Out = (VS_OUTPUT)0;		// sNZf[^ɓnf[^p\
	
	// _WAeNX`W
	Out.Pos = mul(pos, WoldViewProjection);
	Out.MeshUV = mesh_uv;


	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)WorldMatrix));
//	Out.Col = Diffuse*(LightAmbient + LightDiffuse * max(0, dot(-LightDir,w_normal)) );
	Out.Col = MaterialAmbient + MaterialDiffuse*max(0, dot(-LightDirection,w_normal));

	// XyL
	float3 Eye = normalize( Eyepos - mul( pos, WorldMatrix ) );
	float3 r = -Eye + 2.0f * dot( w_normal, Eye ) * w_normal;
//	Out.Spe = Diffuse*Specular * pow(max(0,dot(-LightDir,r)),Power);
	Out.Spe = MaterialSpecular * pow(max(0,dot(-LightDirection,r)),MaterialPower);

	return Out;
}

//===================================================================
// HDRV[_O : SkinMesh_O^[QbgɃ_O
//
// _VF[_
//===================================================================
VS_OUTPUT HDRSceneSkinMeshVertexShader( VS_SKINNING Input , uniform int NumBones)
{
	VS_OUTPUT Output;
	
	VS_SKINNINGOUTPUT SkinOut;
	SkinOut = Vertex_TransformNormal( Input , NumBones );
	
	// ˉeϊ
	//float4x4 Mat = ViewMatrix * ProjectionMatrix;
	Output.Pos = mul( SkinOut.Pos,ViewProjection );
	
	Output.MeshUV = SkinOut.TextureCoord;
	

	// _F
	float3 World_Normal = normalize(SkinOut.Normal);
//	Out.Col = Diffuse*(LightAmbient + LightDiffuse * max(0, dot(-LightDir,w_normal)) );
	Output.Col = MaterialAmbient + MaterialDiffuse*max(0, dot(-LightDirection,World_Normal));

	// XyL
	float3 Eye = normalize( Eyepos - SkinOut.Pos);
	float3 r = -Eye + 2.0f * dot( World_Normal, Eye ) * World_Normal;
//	Out.Spe = Diffuse*Specular * pow(max(0,dot(-LightDir,r)),Power);
	Output.Spe = MaterialSpecular * pow(max(0,dot(-LightDirection,r)),MaterialPower);
	
	return Output;
}
// sNZVF[_
//	EsNZ̐F肵A̐FԂ(R,G,B,Afloat4^)
float4 PS(VS_OUTPUT In) : COLOR
{

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, In.MeshUV) * In.Col + In.Spe;
	//return In.Spe;
}

//==============================================================
// u[VF[_


float4 BloomPixelShader(
	float2 UV : TEXCOORD0
) : COLOR {
	float3 color=0;

//    PixelShader2.0p
//	for(int i=0;i<15;i++)
//	{
//		color+=tex2D(InputSmp, UV+SampleOffset[i])*SampleWeight[i];
//	}
	color+=tex2D(InputSmp, UV+SampleOffset[0])*SampleWeight[0];
	color+=tex2D(InputSmp, UV+SampleOffset[1])*SampleWeight[1];
	color+=tex2D(InputSmp, UV+SampleOffset[2])*SampleWeight[2];

	return float4(color, 1);
}



int CurNumBones = 2;
VertexShader HDRVertexArray[4] = {
				compile vs_1_1 HDRSceneSkinMeshVertexShader(1), 
                            compile vs_1_1 HDRSceneSkinMeshVertexShader(2),
                            compile vs_1_1 HDRSceneSkinMeshVertexShader(3),
                            compile vs_1_1 HDRSceneSkinMeshVertexShader(4)
                          };
                          
                          
//==============================================================
// eNjbN
technique StaticBasic
{
	pass P0
	{
		//CullMode=CCW;
		VertexShader=compile vs_1_1 VS();
		PixelShader=compile ps_1_1 PS();
	}
}
// XLbV
technique SkinBasic
{
	pass Pass0
	{
		//CullMode = CCW;
		VertexShader = ( HDRVertexArray[ CurNumBones ] );
		PixelShader = compile ps_1_1 PS();	
	}
}

technique Bloom
{
	pass P0
	{
		FogEnable=false;
		PixelShader=compile ps_1_4 BloomPixelShader();
	}
}
