// -------------------------------------------------------------
// Perlin Noise
// 
// 
// -------------------------------------------------------------

//#include "_SkinnedMesh.fx"

static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ] : WORLDMATRIXARRAY;
float4 MaterialAmbient : MATERIALAMBIENT;						// 
float4 MaterialDiffuse : MATERIALDIFFUSE;						// gUˌ


// 
float4 LightDiffuse : LIGHTDIFFUSE;							// Cg̊

//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float4 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal;// : NORMAL;
    float4  Diffuse			: COLOR;
    float2  TextureCoord    : TEXCOORD0;
};


// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;		// Wϊ̍s
float4x4 ViewProjection;

float4 LightDir;		// CgxNg
float time;

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
// _̃eNX`
texture RondomTexture;
sampler RondomSampler = sampler_state
{
    Texture = <RondomTexture>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};


texture MeshTexture;
sampler NoiseSampler = sampler_state
{
    Texture = <MeshTexture>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};




// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Col			: COLOR0;
    float3 Tex			: TEXCOORD0;	// fJ[eNX`W
};


//-----------------------------------------------------------------------------------------------------------------------------
// Tv   : Diffuse߂֐
//    : Vector
// ߂l : DiffuseF
//-----------------------------------------------------------------------------------------------------------------------------
float3 Diffuse( float3 Normal , float3 LightVector )
{
    float CosTheta;
    
    // xNgƃCgxNg̓ = Diffuse
    CosTheta = max( 0.0f , dot( Normal , LightVector.xyz ) );
       
       
    return ( CosTheta );
}

//----------------------------------------------------------------------------------------------------------------------------------------
// Tv   : _XLjO֐
//    : XLbV͍\ , _e󂯂{[s̐
// ߂l : XLbVo͍\
//----------------------------------------------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_Skinning( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        NormalVector += mul( Input.Normal , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        
    }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s    
    
    
    // XJ[1.0fŕۊ
    Output.Pos = mul(float4(Position.xyz , 1.0f),ViewProjection);
    
    // Vector𐳋K
    Output.Normal = normalize(  NormalVector  );
    
    
    
    

    // DiffuseZo
    Output.Diffuse.xyz = MaterialAmbient.xyz + Diffuse( NormalVector , LightDiffuse  ) * MaterialDiffuse.xyz;
    Output.Diffuse.w = 1.0f;


    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
    

    
	return Output;
}



VS_OUTPUT SkinVertexNoise(VS_SKINNING Input, uniform int NumBones )
{
	VS_SKINNINGOUTPUT Output = Vertex_Skinning(Input , NumBones);
	
	VS_OUTPUT Out;
	
	Out.Pos = Output.Pos;
	// CeBO
	Out.Col = Output.Diffuse;//max(0,dot(Output.Normal, LightDir.xyz)) + LightDir.w;

	// ʒuKɕϊ
	Out.Tex = 0.5f*Output.Pos+0.5;
	
	return Out;
}


// -------------------------------------------------------------
// V[̕`
// -------------------------------------------------------------
VS_OUTPUT VS(
      float4 Pos      : POSITION,         // [JʒuW
      float3 Normal   : NORMAL            // @xNg
){
	VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	
	// Wϊ
	Out.Pos = mul(Pos, mWVP);
	
	// CeBO
	Out.Col = max(0,dot(Normal, LightDir.xyz)) + LightDir.w;

	// ʒuKɕϊ
	Out.Tex = 0.5f*Pos+0.5;

	return Out;
}
// -------------------------------------------------------------
// P̃IN^[ũmCY֐
// -------------------------------------------------------------
float noise( float gap, float3 pos )
{
	float3 x = gap * pos;
	float3 ix = floor(x)/32.0f;
	float3 fx = frac(x);
	
	float4 x0, x1;

	x0.x = tex3D( RondomSampler, ix + float3(0.f/32.f, 0.f/32.f, 0.f/32.f) ).x;
	x0.y = tex3D( RondomSampler, ix + float3(1.f/32.f, 0.f/32.f, 0.f/32.f) ).x;
	x0.z = tex3D( RondomSampler, ix + float3(0.f/32.f, 1.f/32.f, 0.f/32.f) ).x;
	x0.w = tex3D( RondomSampler, ix + float3(1.f/32.f, 1.f/32.f, 0.f/32.f) ).x;
	
	x1.x = tex3D( RondomSampler, ix + float3(0.f/32.f, 0.f/32.f, 1.f/32.f) ).x;
	x1.y = tex3D( RondomSampler, ix + float3(1.f/32.f, 0.f/32.f, 1.f/32.f) ).x;
	x1.z = tex3D( RondomSampler, ix + float3(0.f/32.f, 1.f/32.f, 1.f/32.f) ).x;
	x1.w = tex3D( RondomSampler, ix + float3(1.f/32.f, 1.f/32.f, 1.f/32.f) ).x;
	
	x0    = lerp(x0.xyzw, x1.xyzw, fx.z);
	x0.xy = lerp(x0.xy,   x0.zw,   fx.y);
	return  lerp(x0.x,    x0.y,    fx.x);
}
// -------------------------------------------------------------
// sNZVF[_
// -------------------------------------------------------------
float4 PS(VS_OUTPUT In) : COLOR
{   
	float4 color = {167.f/256.f, 105.f/256.f, 61.f/256.f, 0};

	float n = 0.5000f * noise( 12.f, In.Tex )
			+ 0.2500f * noise( 24.f, In.Tex );

	//return In.Col * tex2D( NoiseSampler, n+time );
	return In.Col * tex2D( NoiseSampler, In.Tex/*+time*/ );
}


float4 PSS( VS_OUTPUT Out ) : COLOR 
{
	// SellShadersDiffuse͔fȂقǂ
	return float4(1,1,1,1);//tex2D( MeshSmp , MeshUV );// * Diffuse;
}

int CurNumBones = 2;
VertexShader SkinNoise[4] = 
{
				compile vs_1_1 SkinVertexNoise(1), 
                            compile vs_1_1 SkinVertexNoise(2),
                            compile vs_1_1 SkinVertexNoise(3),
                            compile vs_1_1 SkinVertexNoise(4)
};


                          

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}


technique SkinMeshNoise
{
    pass Pass0
    {
	 CullMode = CCW;               // wʃJO
        VertexShader = ( SkinNoise[CurNumBones] );
        PixelShader = compile ps_2_0 PS();
    }
}
