//---------------------------------------------------------------------------
// x}bv𗘗p[Vu[
//---------------------------------------------------------------------------


//==========================================================================
// eNX`
//==========================================================================
texture		MeshTexture;			// fJ[eNX`
texture		RenderTarget;			// ʏ`peNX`
texture		VelocityMap;		// x}bv

//===========================================================================
// staticMesn
//===========================================================================
float4x4	WorldViewProjection;			// ϊs
float4x4	OldWorldViewProjection;		// O̕ϊs
float4x4	WorldViewMatrix;				// [hEr[s
float4x4	OldWorldViewMatrix;			// Õ[hEr[s
float3		vLight;				// CgxNgi[Jj




// _VF[_
struct VS_INPUT0
{
	float4	vPos	: POSITION;
	float3	vNorm	: NORMAL0;
	float2	vTex	: TEXCOORD0;
};
struct VS_INPUT1
{
	float4	vPos	: POSITION;
	float2	vTex	: TEXCOORD0;
};

// _VF[_o
struct VS_OUTPUT0{
	float4	vPos	: POSITION;
	float4	vCol	: COLOR0;
	float2	vTex	: TEXCOORD0;
};
struct VS_OUTPUT1{
	float4	vPos	: POSITION;
	float2	vTex	: TEXCOORD0;
};

// Tv
sampler MeshSampler = sampler_state
{
	texture = <MeshTexture>;
	AddressU = WRAP;
	AddressV = WRAP;
};
sampler RenderTargetSampler = sampler_state
{
	texture = <RenderTarget>;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
sampler VelocityMapSampler = sampler_state
{
	texture = <VelocityMap>;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// _VF[_
// ʏ`
VS_OUTPUT0 vsNormalDraw(const VS_INPUT0 v)
{
	VS_OUTPUT0	o = (VS_OUTPUT0)0;

	// Wϊ
	o.vPos = mul(v.vPos, WorldViewProjection);

	// eNX`W
	o.vTex = v.vTex;

	// CgxNg
	o.vCol.xyz = dot(vLight, v.vNorm);
	o.vCol.w = 1.0f;

	return o;
}
//========================================================================================
// x}bv`
//========================================================================================
VS_OUTPUT0 CreateVelocityMapVertexShader(const VS_INPUT0 v)
{
	VS_OUTPUT0	o = (VS_OUTPUT0)0;
	float4		now_pos, prev_pos, n;
	float3		vel, norm;
	float		d;

	// ƑÖʒuvZ
	now_pos  = mul(v.vPos, WorldViewMatrix);
	prev_pos = mul(v.vPos, OldWorldViewMatrix);

	// x߂
	vel.xyz = now_pos.xyz - prev_pos.xyz;

	// @]
	n.xyz = v.vNorm;
	n.w = 0.0f;
	norm.xyz = mul(n, WorldViewMatrix);

	// Wϊ
	now_pos  = mul(v.vPos, WorldViewProjection);
	prev_pos = mul(v.vPos, OldWorldViewProjection);

	// @Ƒx̃xNg̓ςo͂钸_f[^肷
	d = dot(norm, vel);
	d = step(0.0f, d);
	o.vPos = d * now_pos + (1.0f - d) * prev_pos;

	// J[ɑxo͂
	now_pos.xy = now_pos.xy / now_pos.w;
	prev_pos.xy = prev_pos.xy / prev_pos.w;
	o.vTex.x = (now_pos.x - prev_pos.x);
	o.vTex.y = -(now_pos.y - prev_pos.y);

	return o;
}

// ŏI`
VS_OUTPUT1 vsFinal(const VS_INPUT1 v)
{
	VS_OUTPUT1	o = (VS_OUTPUT1)0;

	// W
	o.vPos = v.vPos;

	// eNX`W
	o.vTex = v.vTex;

	return o;
}

// sNZVF[_
// ʏ`
pixelshader psNormalDraw = 
asm{
	ps_1_1
	def c0, 0.3f, 0.3f, 0.3f, 1.0f

	tex t0
	mul r0, t0, v0
	add r0, r0, c0
	mov r0.a, t0.a
};
// x}bv
float4 psVelocity(const VS_OUTPUT1 v) : COLOR
{
	float4	Out;

	Out.rg = v.vTex.xy;
	Out.ba = 1.0f;

	return Out;
}
// ŏI`
float4 FinalPixelShader(const VS_OUTPUT1 v) : COLOR
{
	float4	Out;
	float2	vel;

	// _O^[Qbgɕ`悵eƑx}bv̍
	vel = tex2D(VelocityMapSampler, v.vTex) / 3.0f;
	Out = tex2D( RenderTargetSampler , v.vTex )
		+ tex2D(RenderTargetSampler, v.vTex + vel * 1.0f)
		+ tex2D(RenderTargetSampler, v.vTex + vel * 2.0f)
		+ tex2D(RenderTargetSampler, v.vTex + vel * 3.0f);
	Out = Out / 4.0f;

	return Out;
}

// AZu
pixelshader psFinal2 = 
asm{
	ps_1_1

	tex t0
	mov r0, t0
};

//==========================================================================================
//
// eNjbN
//
//==========================================================================================
// ʏ`
technique StaticBaseHLSL
{
	pass Pass0
	{
		VertexShader = compile vs_1_1 vsNormalDraw();
		PixelShader = <psNormalDraw>;

		ZEnable = TRUE;
		AlphaBlendEnable = False;

		Sampler[0] = <MeshSampler>;
	}
}
// x}bv̍쐬
technique CreateVelocityMap
{
	pass Pass0
	{
		VertexShader = compile vs_1_1 CreateVelocityMapVertexShader();
		PixelShader = compile ps_2_0 psVelocity();

		ZEnable = TRUE;
		AlphaBlendEnable = False;
	}
}

//============================================================================
// ŏI` : ăfoCXɏo
//============================================================================
technique Output
{
	pass Pass0
	{
		VertexShader = compile vs_1_1 vsFinal();
		PixelShader = compile ps_2_0 FinalPixelShader();

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}
// ʏ`\
technique Tec4_Normal
{
	pass Pass0
	{
		VertexShader = compile vs_1_1 vsFinal();
		PixelShader = <psFinal2>;

		Sampler[0] = <RenderTargetSampler>;

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}
//=============================================================================
// x}bv\
//=============================================================================
technique RenderVelocityMap
{
	pass Pass0
	{
		VertexShader = compile vs_1_1 vsFinal();
		PixelShader = <psFinal2>;

		Sampler[0] = <VelocityMapSampler>;

		ZEnable = False;
		AlphaBlendEnable = False;
	}
}
